## hyprwire 0.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

file(READ "${CMAKE_SOURCE_DIR}/VERSION" VER_RAW)
string(STRIP ${VER_RAW} HYPRWIRE_VERSION)

add_compile_definitions(HYPRWIRE_VERSION="${HYPRWIRE_VERSION}")

project(
  hyprwire
  VERSION ${HYPRWIRE_VERSION}
  DESCRIPTION "A fast and consistent wire protocol for IPC")

include(CTest)
include(CheckIncludeFile)
include(GNUInstallDirs)

add_subdirectory(scanner)

set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDE ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})

find_package(PkgConfig REQUIRED)
pkg_check_modules(
  deps
  REQUIRED
  IMPORTED_TARGET
  hyprutils>=0.9.0
  libffi
)

configure_file(hyprwire.pc.in hyprwire.pc @ONLY)

set(CMAKE_CXX_STANDARD 23)
add_compile_options(
  -Wall
  -Wextra
  -Wno-unused-parameter
  -Wno-unused-value
  -Wno-missing-field-initializers
  -Wpedantic)
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
  message(STATUS "Configuring hyprwire in Debug")
  add_compile_definitions(HYPRWIRE_DEBUG)
else()
  add_compile_options(-O3)
  message(STATUS "Configuring hyprwire in Release")
endif()

add_compile_definitions(HT_HIDDEN=public)

file(GLOB_RECURSE SRCFILES CONFIGURE_DEPENDS "src/*.cpp" "include/*.hpp")
file(GLOB_RECURSE PUBLIC_HEADERS CONFIGURE_DEPENDS "include/*.hpp")

execute_process(COMMAND ./scripts/generateShaderIncludes.sh
                WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_library(hyprwire SHARED ${SRCFILES})
target_include_directories(
  hyprwire
  PUBLIC "./include"
  PRIVATE "./src" "${CMAKE_BINARY_DIR}")
set_target_properties(hyprwire PROPERTIES VERSION ${HYPRWIRE_VERSION} SOVERSION
                                                                      1)
target_link_libraries(hyprwire PkgConfig::deps)

check_include_file("sys/timerfd.h" HAS_TIMERFD)
pkg_check_modules(epoll IMPORTED_TARGET epoll-shim)
if(NOT HAS_TIMERFD AND epoll_FOUND)
  target_link_libraries(hyprwire PkgConfig::epoll)
endif()

# helper func
function(protocol proto_dir proto_name is_client out_base out_var)
  if(is_client)
    set(mode "--client")
    set(suffix "client")
  else()
    set(mode "")
    set(suffix "server")
  endif()

  set(outdir "${CMAKE_SOURCE_DIR}/tests/generated")
  set(xml_in "${proto_dir}/${proto_name}.xml")

  set(tmp_cpp "${outdir}/${proto_name}-${suffix}.cpp")
  set(tmp_hpp "${outdir}/${proto_name}-${suffix}.hpp")

  set(out_cpp "${outdir}/${out_base}-${suffix}.cpp")
  set(out_hpp "${outdir}/${out_base}-${suffix}.hpp")

  add_custom_command(
    OUTPUT "${out_cpp}" "${out_hpp}"
    COMMAND "${CMAKE_COMMAND}" -E make_directory "${outdir}"
    COMMAND hyprwire-scanner ${mode} "${xml_in}" "${outdir}"
    DEPENDS hyprwire-scanner "${xml_in}"
    VERBATIM
    COMMENT
      "Generating ${suffix} protocol from ${proto_name}.xml -> ${out_base}-${suffix}.{cpp,hpp}"
  )

  set(${out_var}
      "${out_cpp};${out_hpp}"
      PARENT_SCOPE)
endfunction()

# tests
if(BUILD_TESTING)
  message(STATUS "building tests is enabled")

  enable_testing()
  add_custom_target(tests)

  message(STATUS "generating protocols")
  protocol("${CMAKE_SOURCE_DIR}/tests" "protocol-v1" TRUE "test_protocol_v1"
           CLIENT_GEN)
  protocol("${CMAKE_SOURCE_DIR}/tests" "protocol-v1" FALSE "test_protocol_v1"
           SERVER_GEN)
  add_executable(client "${CMAKE_SOURCE_DIR}/tests/Client.cpp"
                        "tests/generated/test_protocol_v1-client.cpp")
  target_link_libraries(client PRIVATE PkgConfig::deps hyprwire)
  add_dependencies(tests client)

  add_executable(server "${CMAKE_SOURCE_DIR}/tests/Server.cpp"
                        "tests/generated/test_protocol_v1-server.cpp")
  target_link_libraries(server PRIVATE PkgConfig::deps hyprwire)
  add_dependencies(tests server)
else()
  message(STATUS "building tests is disabled")
endif()

# Installation
install(TARGETS hyprwire)
install(DIRECTORY "include/hyprwire" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_BINARY_DIR}/hyprwire.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== scanner/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

project(
  hyprwire-scanner
  DESCRIPTION "A protocol code generator for hyprwire"
  VERSION ${HYPRWIRE_VERSION})

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(PREFIX ${CMAKE_INSTALL_PREFIX})

set(CMAKE_MESSAGE_LOG_LEVEL "STATUS")

# configure
set(CMAKE_CXX_STANDARD 23)
add_compile_options(-Wall -Wextra -Wno-unused-parameter -Wno-unused-value
                    -Wno-missing-field-initializers -Wno-narrowing)

add_compile_definitions(SCANNER_VERSION="${HYPRWIRE_VERSION}")

configure_file(hyprwire-scanner.pc.in hyprwire-scanner.pc @ONLY)

# dependencies
message(STATUS "Checking deps...")

find_package(Threads REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET pugixml)

add_executable(hyprwire-scanner main.cpp)
target_link_libraries(hyprwire-scanner PRIVATE rt Threads::Threads
                                               PkgConfig::deps)

target_include_directories(hyprwire-scanner
                           PUBLIC "${CMAKE_SOURCE_DIR}/include")

configure_package_config_file(
  hyprwire-scanner-config.cmake.in hyprwire-scanner-config.cmake
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/hyprwire-scanner"
  PATH_VARS CMAKE_INSTALL_BINDIR)
write_basic_package_version_file(
  "hyprwire-scanner-config-version.cmake"
  VERSION "${VERSION}" ARCH_INDEPENDENT
  COMPATIBILITY AnyNewerVersion)

# Installation
install(TARGETS hyprwire-scanner)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/hyprwire-scanner.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/hyprwire-scanner-config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/hyprwire-scanner-config-version.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/hyprwire-scanner)

=== debian/changelog ===
hyprwire (0.1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1118694)

 -- Carl Keinath <carl.keinath@gmail.com>  Fri, 05 Dec 2025 23:08:43 +0800

=== debian/control ===
Source: hyprwire
Section: libs
Priority: optional
Maintainer: Debian Hyprland Maintainers <team+hyprland@tracker.debian.org>
Uploaders:
 Carl Keinath <carl.keinath@gmail.com>,
 Chow Loong Jin <hyperair@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 libhyprutils-dev (>= 0.9.0),
 libffi-dev,
 libpugixml-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/hyprwm/hyprwire
Vcs-Browser: https://salsa.debian.org/hyprland-team/hyprwire
Vcs-Git: https://salsa.debian.org/hyprland-team/hyprwire.git

Package: libhyprwire-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libhyprwire1 (= ${binary:Version}),
 ${misc:Depends},
Description: Fast and consistent wire protocol for IPC -- development files
 Hyprwire is a fast and consistent wire protocol, and its implementation. This
 is essentially a "method" for processes to talk to each other. It is heavily
 inspired by Wayland, and heavily anti-inspired by D-Bus.
 .
 Hyprwire is:
  - Strict: both sides need to be on the same page to communicate. No "random
    data" is allowed.
  - Fast: initial handshakes are very simple and allow for quick information
    exchange (including one-shot operations)
  - Simple to use: the API uses modern C++ and abstracts away any
    memory-sensitive operations
  - Simple internally: the protocol itself is simple and straightforward to
    parse / write your own implementation
 .
 This package contains the headers and other development support files needed
 for compiling and linking applications and libraries which use this library.

Package: libhyprwire1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Fast and consistent wire protocol for IPC -- binary files
 Hyprwire is a fast and consistent wire protocol, and its implementation. This
 is essentially a "method" for processes to talk to each other. It is heavily
 inspired by Wayland, and heavily anti-inspired by D-Bus.
 .
 Hyprwire is:
  - Strict: both sides need to be on the same page to communicate. No "random
    data" is allowed.
  - Fast: initial handshakes are very simple and allow for quick information
    exchange (including one-shot operations)
  - Simple to use: the API uses modern C++ and abstracts away any
    memory-sensitive operations
  - Simple internally: the protocol itself is simple and straightforward to
    parse / write your own implementation
 .
 This package contains the shared library needed for running applications which
 use this library.

Package: hyprwire-scanner
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libpugixml1v5,
Description: Scanner for the Hyprwire protocol
 Hyprwire is a fast and consistent wire protocol, and its implementation. This
 is essentially a "method" for processes to talk to each other. It is heavily
 inspired by Wayland, and heavily anti-inspired by D-Bus.
 .
 Hyprwire is:
  - Strict: both sides need to be on the same page to communicate. No "random
    data" is allowed.
  - Fast: initial handshakes are very simple and allow for quick information
    exchange (including one-shot operations)
  - Simple to use: the API uses modern C++ and abstracts away any
    memory-sensitive operations
  - Simple internally: the protocol itself is simple and straightforward to
    parse / write your own implementation
 .
 This package provides the Hyprwire protocol scanner for generating
 application interfaces.

## hyprwire 0.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -63,7 +63,7 @@
   PUBLIC "./include"
   PRIVATE "./src" "${CMAKE_BINARY_DIR}")
 set_target_properties(hyprwire PROPERTIES VERSION ${HYPRWIRE_VERSION} SOVERSION
-                                                                      1)
+                                                                      2)
 target_link_libraries(hyprwire PkgConfig::deps)
 
 check_include_file("sys/timerfd.h" HAS_TIMERFD)

=== debian/changelog ===
hyprwire (0.2.1-1) unstable; urgency=medium

  * New upstream version 0.2.1
  * bump SOVERSION for libhyprwire
  * update autopkgtest suite:
    - append expected strings
    - make sure client has exited

 -- Carl Keinath <carl.keinath@gmail.com>  Sun, 07 Dec 2025 13:13:17 +0100

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprwire1 (= ${binary:Version}),
+ libhyprwire2 (= ${binary:Version}),
  ${misc:Depends},
 Description: Fast and consistent wire protocol for IPC -- development files
  Hyprwire is a fast and consistent wire protocol, and its implementation. This
@@ -42,7 +42,7 @@
  This package contains the headers and other development support files needed
  for compiling and linking applications and libraries which use this library.
 
-Package: libhyprwire1
+Package: libhyprwire2
 Architecture: any
 Multi-Arch: same
 Depends:

## hyprwire 0.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -63,7 +63,7 @@
   PUBLIC "./include"
   PRIVATE "./src" "${CMAKE_BINARY_DIR}")
 set_target_properties(hyprwire PROPERTIES VERSION ${HYPRWIRE_VERSION} SOVERSION
-                                                                      2)
+                                                                      3)
 target_link_libraries(hyprwire PkgConfig::deps)
 
 check_include_file("sys/timerfd.h" HAS_TIMERFD)
@@ -127,6 +127,12 @@
                         "tests/generated/test_protocol_v1-server.cpp")
   target_link_libraries(server PRIVATE PkgConfig::deps hyprwire)
   add_dependencies(tests server)
+
+  add_executable(fork "${CMAKE_SOURCE_DIR}/tests/Fork.cpp"
+                        "tests/generated/test_protocol_v1-client.cpp"
+                        "tests/generated/test_protocol_v1-server.cpp")
+  target_link_libraries(fork PRIVATE PkgConfig::deps hyprwire)
+  add_dependencies(tests fork)
 else()
   message(STATUS "building tests is disabled")
 endif()

=== scanner/CMakeLists.txt ===
--- 
+++ 
@@ -28,8 +28,15 @@
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(deps REQUIRED IMPORTED_TARGET pugixml)
 
+find_library(librt rt)
+if("${librt}" MATCHES "librt-NOTFOUND")
+  unset(LIBRT)
+else()
+  set(LIBRT rt)
+endif()
+
 add_executable(hyprwire-scanner main.cpp)
-target_link_libraries(hyprwire-scanner PRIVATE rt Threads::Threads
+target_link_libraries(hyprwire-scanner PRIVATE ${LIBRT} Threads::Threads
                                                PkgConfig::deps)
 
 target_include_directories(hyprwire-scanner

=== debian/changelog ===
hyprwire (0.3.0-3) unstable; urgency=medium

  * d/patches: write full 32-bit object id in resolveSeq

 -- Carl Keinath <carl.keinath@gmail.com>  Sun, 15 Feb 2026 17:09:13 +0100

hyprwire (0.3.0-2) unstable; urgency=medium

  * Fix autopkgtest on slow architectures

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 09 Feb 2026 13:34:59 +0800

hyprwire (0.3.0-1) unstable; urgency=medium

  * New upstream version 0.3.0
  * Rename library for soname bump

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 06 Feb 2026 11:40:50 +0800

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprwire2 (= ${binary:Version}),
+ libhyprwire3 (= ${binary:Version}),
  ${misc:Depends},
 Description: Fast and consistent wire protocol for IPC -- development files
  Hyprwire is a fast and consistent wire protocol, and its implementation. This
@@ -42,7 +42,7 @@
  This package contains the headers and other development support files needed
  for compiling and linking applications and libraries which use this library.
 
-Package: libhyprwire2
+Package: libhyprwire3
 Architecture: any
 Multi-Arch: same
 Depends:

=== debian/watch ===
Version: 5

Template: GitHub
Owner: hyprwm
Project: hyprwire
